<template>
  <q-toolbar class="bg-primary text-white raised">
    <q-toolbar-title role="heading">Referenties
      <q-badge align="top" outline v-if="references_filtered">
        {{ references_filtered.length }}
      </q-badge>
      <q-badge align="top" outline v-else>0</q-badge>
    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" autofocus>
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
      <q-select label="Bron" v-model="f_name" :options="get_reference_names"></q-select>
    </q-card-section>
  </q-card>
  <div>
    <q-virtual-scroll :items="references_filtered" role="region" aria-label="Lijst referenties"
                      virtual-scroll-slice-size="60" bordered virtual-scroll-item-size="48" class="scroll_list">
      <template v-slot="{ item }">
        <q-item clickable v-ripple
                v-bind:id="item.id"
                v-bind:key="item.id"
                :to="{name: 'reference_detail', params: {reference_id: item.id}}"
                active-class="active"
                title="Klik voor details"
                tabindex="0">
          <q-item-section>
            <q-item-label>{{ item.name }}</q-item-label>
            <q-item-label caption class="non__breaking">{{ item.id }}</q-item-label>
          </q-item-section>
        </q-item>
      </template>
    </q-virtual-scroll>
    <q-inner-loading :showing="typeof references=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof references=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </div>
</template>

<script>
import {api} from 'boot/axios'
import _ from 'lodash'

export default {
  name: "ReferenceList",
  created() {
    this.fetchData()
  },
  data() {
    return {
      references: undefined,
      search_value: '',
      f_name: '',
    }
  },
  props: {
    dts_name: String,
    nt_version: String
  },

  methods: {
    fetchData: function () {
      api
        .get("/dts/" + this.dts_name + "/references", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.references = response.data
          if (this.references.length && this.$route.fullPath.endsWith('references')) {
            this.$router.push({
              name: 'reference_detail',
              replace: true,
              params: {reference_id: this.references[0].id}
            })
          } else {
            this.$nextTick(() => {
              this.scroll_to_active()
            })
          }
        })
        .catch((error) => {
          this.references = []
        })

    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }
  },
  computed: {
    references_filtered() {
      let filtered = this.references
      if (this.f_name !== '') {
        filtered = filtered.filter(reference => reference.name === this.f_name)
      }
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return filtered.filter(ref => ref.id &&
          (ref.id.toLowerCase().includes(this.search_value.toLowerCase()) ||
            ref.name.toLowerCase().includes(this.search_value.toLowerCase()))
        )
      } else {
        return filtered
      }
    },
    get_reference_names() {
      if (typeof (this.references) !== 'undefined') {
        let nameslist = ['']
        this.references.forEach(reference => {
          nameslist.push(reference.name)
        })
        return _.orderBy(_.uniq(nameslist))
      } else {
        return []
      }
    }
  }
}
</script>

<style scoped lang="scss">
.active {
  background: $list_selected_bg;
  color: white;
  opacity: 0.9;
}

.active .q-item__label--caption {
  color: #eee;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 345px);
}

.non__breaking {
  white-space: nowrap;
}

</style>
